3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE
=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
49 dotest
="$GIT_DIR"/rebase-merge
53 test "$(git config --bool rebase.stat)" = true
&& diffstat
=t
57 allow_rerere_autoupdate
=
60 test -n "$prev_head" || die
"prev_head must be defined"
61 test -d "$dotest" || die
"$dotest directory does not exist"
63 unmerged
=$
(git ls-files
-u)
64 if test -n "$unmerged"
66 echo "You still have unmerged paths in your index"
67 echo "did you forget to use git add?"
71 cmt
=`cat "$dotest/current"`
72 if ! git diff-index
--quiet --ignore-submodules HEAD
--
74 if ! git commit
--no-verify -C "$cmt"
76 echo "Commit failed, please do not call \"git commit\""
77 echo "directly, but instead do one of the following: "
80 if test -z "$GIT_QUIET"
82 printf "Committed: %0${prec}d " $msgnum
84 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
86 if test -z "$GIT_QUIET"
88 printf "Already applied: %0${prec}d " $msgnum
91 test -z "$GIT_QUIET" &&
92 GIT_PAGER
='' git log
--format=%s
-1 "$cmt"
94 prev_head
=`git rev-parse HEAD^0`
95 # save the resulting commit so we can read-tree on it later
96 echo "$prev_head" > "$dotest/prev_head"
98 # onto the next patch:
99 msgnum
=$
(($msgnum + 1))
100 echo "$msgnum" >"$dotest/msgnum"
104 cmt
="$(cat "$dotest/cmt.
$1")"
105 echo "$cmt" > "$dotest/current"
106 hd
=$
(git rev-parse
--verify HEAD
)
107 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
108 msgnum
=$
(cat "$dotest/msgnum")
109 end
=$
(cat "$dotest/end")
110 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
111 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
112 export GITHEAD_
$cmt GITHEAD_
$hd
113 if test -n "$GIT_QUIET"
115 GIT_MERGE_VERBOSITY
=1 && export GIT_MERGE_VERBOSITY
117 eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
121 unset GITHEAD_
$cmt GITHEAD_
$hd
125 git rerere
$allow_rerere_autoupdate
129 echo "Strategy: $rv $strategy failed, try another" 1>&2
133 die
"Unknown exit code ($rv) from command:" \
134 "git-merge-$strategy $cmt^ -- HEAD $cmt"
139 move_to_original_branch
() {
140 test -z "$head_name" &&
141 head_name
="$(cat "$dotest"/head-name)" &&
142 onto
="$(cat "$dotest"/onto)" &&
143 orig_head
="$(cat "$dotest"/orig-head)"
146 message
="rebase finished: $head_name onto $onto"
147 git update-ref
-m "$message" \
148 $head_name $
(git rev-parse HEAD
) $orig_head &&
149 git symbolic-ref HEAD
$head_name ||
150 die
"Could not move back to $head_name"
156 move_to_original_branch
157 git notes copy
--for-rewrite=rebase
< "$dotest"/rewritten
158 if test -x "$GIT_DIR"/hooks
/post-rewrite
&&
159 test -s "$dotest"/rewritten
; then
160 "$GIT_DIR"/hooks
/post-rewrite rebase
< "$dotest"/rewritten
171 interactive_rebase
=explicit
174 -p|
--preserve-merges)
175 interactive_rebase
=implied
181 if [ "$interactive_rebase" = implied
]; then
186 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
189 run_pre_rebase_hook
() {
190 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
191 test -x "$GIT_DIR/hooks/pre-rebase"
193 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
194 die
"The pre-rebase hook refused to rebase."
198 test -f "$GIT_DIR"/rebase-apply
/applying
&&
199 die
'It looks like git-am is in progress. Cannot rebase.'
201 is_interactive
"$@" && exec git-rebase--interactive
"$@"
207 OK_TO_SKIP_PRE_REBASE
=yes
210 OK_TO_SKIP_PRE_REBASE
=
213 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
214 die
"No rebase in progress?"
216 git update-index
--ignore-submodules --refresh &&
217 git diff-files
--quiet --ignore-submodules ||
{
218 echo "You must edit all merge conflicts and then"
219 echo "mark them as resolved using git add"
224 prev_head
=$
(cat "$dotest/prev_head")
225 end
=$
(cat "$dotest/end")
226 msgnum
=$
(cat "$dotest/msgnum")
227 onto
=$
(cat "$dotest/onto")
228 GIT_QUIET
=$
(cat "$dotest/quiet")
230 while test "$msgnum" -le "$end"
238 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
239 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
240 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
241 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
242 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
243 move_to_original_branch
247 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
248 die
"No rebase in progress?"
250 git
reset --hard HEAD ||
exit $?
254 prev_head
=$
(cat "$dotest/prev_head")
255 end
=$
(cat "$dotest/end")
256 msgnum
=$
(cat "$dotest/msgnum")
257 msgnum
=$
(($msgnum + 1))
258 onto
=$
(cat "$dotest/onto")
259 GIT_QUIET
=$
(cat "$dotest/quiet")
260 while test "$msgnum" -le "$end"
268 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
269 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
270 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
271 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
272 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
273 move_to_original_branch
277 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
278 die
"No rebase in progress?"
282 test -d "$dotest" || dotest
="$GIT_DIR"/rebase-apply
284 head_name
="$(cat "$dotest"/head-name)" &&
287 git symbolic-ref HEAD
$head_name ||
288 die
"Could not move back to $head_name"
291 git
reset --hard $
(cat "$dotest/orig-head")
296 test 2 -le "$#" || usage
300 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
303 -X*|
--strategy-option*)
305 1,-X|
1,--strategy-option)
307 *,-X|
*,--strategy-option)
310 *,--strategy-option=*)
311 newopt
="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
313 newopt
="$(expr " $1" : ' -X\(.*\)')" ;;
317 strategy_opts
="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
320 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
321 --strateg=*|
--strategy=*|\
322 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
325 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
347 git_am_opt
="$git_am_opt -q"
352 git_am_opt
="$git_am_opt $1"
354 --whitespace=fix|
--whitespace=strip
)
360 git_am_opt
="$git_am_opt $1"
362 --committer-date-is-author-date|
--ignore-date)
363 git_am_opt
="$git_am_opt $1"
367 git_am_opt
="$git_am_opt $1"
372 -f|
--f|
--fo|
--for|
--forc|
--force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase|
--no-ff)
375 --rerere-autoupdate|
--no-rerere-autoupdate)
376 allow_rerere_autoupdate
="$1"
387 test $# -gt 2 && usage
389 if test $# -eq 0 && test -z "$rebase_root"
391 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
392 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
393 die
'A rebase is in progress, try --continue, --skip or --abort.'
396 # Make sure we do not have $GIT_DIR/rebase-apply
397 if test -z "$do_merge"
399 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
401 rmdir "$GIT_DIR"/rebase-apply
404 It seems that I cannot create a rebase-apply directory, and
405 I wonder if you are in the middle of patch application or another
406 rebase. If that is not the case, please
407 rm -fr '"$GIT_DIR"'/rebase-apply
408 and run me again. I am stopping in case you still have something
415 die
"previous rebase directory $dotest still exists." \
416 'Try git rebase (--continue | --abort | --skip)'
420 require_clean_work_tree
"rebase" "Please commit or stash them."
422 if test -z "$rebase_root"
424 # The upstream head must be given. Make sure it is valid.
427 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
428 die
"invalid upstream $upstream_name"
430 upstream_arg
="$upstream_name"
432 test -z "$newbase" && die
"--root must be used with --onto"
436 upstream_arg
="$root_flag"
439 # Make sure the branch to rebase onto is valid.
440 onto_name
=${newbase-"$upstream_name"}
443 if left
=${onto_name%...*} right
=${onto_name#*...} &&
444 onto
=$
(git merge-base
--all ${left:-HEAD} ${right:-HEAD})
448 die
"$onto_name: there are more than one merge bases"
451 die
"$onto_name: there is no merge base"
455 die
"$onto_name: there is no merge base"
459 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
463 # If a hook exists, give it a chance to interrupt
464 run_pre_rebase_hook
"$upstream_arg" "$@"
466 # If the branch to rebase is given, that is the branch we will rebase
467 # $branch_name -- branch being rebased, or HEAD (already detached)
468 # $orig_head -- commit object name of tip of the branch before rebasing
469 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
473 # Is it "rebase other $branchname" or "rebase other $commit"?
477 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
478 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
480 head_name
="refs/heads/$1"
481 elif branch
=$
(git rev-parse
-q --verify "$1")
483 head_name
="detached HEAD"
485 echo >&2 "fatal: no such branch: $1"
490 # Do not need to switch branches, we are already on it.
491 if branch_name
=`git symbolic-ref -q HEAD`
493 head_name
=$branch_name
494 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
496 head_name
="detached HEAD"
497 branch_name
=HEAD
;# detached
499 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
504 # Now we are rebasing commits $upstream..$branch (or with --root,
505 # everything leading up to $branch) on top of $onto
507 # Check if we are already based on $onto with linear history,
508 # but this should be done only when upstream and onto are the same.
509 mb
=$
(git merge-base
"$onto" "$branch")
510 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
512 ! (git rev-list
--parents "$onto"..
"$branch" | sane_grep
" .* ") > /dev
/null
514 if test -z "$force_rebase"
516 # Lazily switch to the target branch if needed...
517 test -z "$switch_to" || git checkout
"$switch_to" --
518 say
"Current branch $branch_name is up to date."
521 say
"Current branch $branch_name is up to date, rebase forced."
525 # Detach HEAD and reset the tree
526 say
"First, rewinding head to replay your work on top of it..."
527 git checkout
-q "$onto^0" || die
"could not detach HEAD"
528 git update-ref ORIG_HEAD
$branch
530 if test -n "$diffstat"
532 if test -n "$verbose"
534 echo "Changes from $mb to $onto:"
536 # We want color (if set), but no pager
537 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
540 # If the $onto is a proper descendant of the tip of the branch, then
541 # we just fast-forwarded.
542 if test "$mb" = "$branch"
544 say
"Fast-forwarded $branch_name to $onto_name."
545 move_to_original_branch
549 if test -n "$rebase_root"
551 revisions
="$onto..$orig_head"
553 revisions
="$upstream..$orig_head"
556 if test -z "$do_merge"
558 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
559 --src-prefix=a
/ --dst-prefix=b
/ \
560 --no-renames $root_flag "$revisions" |
561 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
562 move_to_original_branch
564 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
565 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
566 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
567 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
568 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
572 # start doing a rebase with git-merge
573 # this is rename-aware if the recursive (default) strategy is used
576 echo "$onto" > "$dotest/onto"
577 echo "$onto_name" > "$dotest/onto_name"
579 echo "$prev_head" > "$dotest/prev_head"
580 echo "$orig_head" > "$dotest/orig-head"
581 echo "$head_name" > "$dotest/head-name"
582 echo "$GIT_QUIET" > "$dotest/quiet"
585 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
587 msgnum
=$
(($msgnum + 1))
588 echo "$cmt" > "$dotest/cmt.$msgnum"
591 echo 1 >"$dotest/msgnum"
592 echo $msgnum >"$dotest/end"
597 while test "$msgnum" -le "$end"